// Copyright (c) 2023 Dominic Masters
// 
// This software is released under the MIT License.
// https://opensource.org/licenses/MIT

#pragma once
#include "MeshHost.hpp"
#include "display/mesh/QuadMesh.hpp"

namespace Dawn {
  class QuadMeshHost : public MeshHost {
    public:
      // @optional
      StateProperty<glm::vec2> xy0;
      // @optional
      StateProperty<glm::vec2> xy1;
      // @optional
      StateProperty<glm::vec2> uv0;
      // @optional
      StateProperty<glm::vec2> uv1;

      QuadMeshHost(SceneItem *item);
      void onStart() override;
  };
}